/****************************************************************************

	File    : check\check.c  

	Project : server
	Version : 3.7
	Date    : Sat, 22, Sep 2018 

	Author  : Zheltikov I.A.

****************************************************************************/

#include "check/check.h"
#include "sample/sample_lib.h"
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/neutrino.h>


// ---------------------------------------------------------------> main <---

int main(int argc, char** argv)
{
	int fd;
	int chid, coid;
	int in, out, rc, out_len;
	char in_vec [100];
	char out_vec [100];
	struct _pulse pulse;
	struct sigevent event;

	chid = ChannelCreate (0);
	if (chid == -1) {
		printf ("Can not create channel\n");
		return 1;
	}

	coid = ConnectAttach (0, 0, chid, _NTO_SIDE_CHANNEL, 0);
	if (coid == -1) {
		printf ("Can not connect\n");
		return 1;
	}

	SIGEV_PULSE_INIT (&event, coid, SIGEV_PULSE_PRIO_INHERIT,
		_PULSE_CODE_MINAVAIL, 0);

	fd = se_OpenErr (sa_name, 0);

	rc = se_EventForDelivering (fd, &event);
	printf ("check  event for delivering  rc=%d\n", rc);

	rc = sa_Cmd (fd);

	in = 1;
	rc = sa_In (fd, in);
	printf ("check  in   rc=%d  err=%d  in=%d\n", rc, errno, in);

	rc = sa_Out (fd, &out);
	printf ("check  out   rc=%d  err=%d  out=%d\n", rc, errno, out);

	in = 2;
	rc = sa_InOut (fd, in, &out);
	printf ("check  inout   rc=%d  err=%d  in=%d   out=%d\n",
		rc, errno, in, out);

	in = 10;
	sa_Pulse (fd, in);
	delay (100);

	in = 20;
	printf ("check  before delayed\n");
	rc = sa_Delayed (fd, in, &out);
	printf ("check  delayed   rc=%d  err=%d  in=%d   out=%d\n",
		rc, errno, in, out);

	rc = MsgReceivePulse (chid, &pulse, sizeof (struct _pulse), NULL);
	printf ("check  received pulse   rc=%d  err=%d  value=%d\n",
		rc, errno, pulse.value.sival_int);

	strcpy (in_vec, "How do you do?");
	out_len = sizeof (out_vec);
	rc = sa_Vectors (fd, in_vec, strlen (in_vec) + 1, out_vec, &out_len);
	printf ("check  vectors  out='%s'   len=%d\n", out_vec, out_len);

	se_Complete (fd);
	//	se_CompleteByPulse (fd);

	ConnectDetach (coid);
	ChannelDestroy (chid);

	return EXIT_SUCCESS;
}

//===========================================================================

