/****************************************************************************

	File    : program\program_ser.c  

	Project : server
	Version : 1.0
	Date    : Sat, 22, Sep 2018 

	Author  : Zheltikov I.A.

****************************************************************************/

#include "program/program_ser.h"
#include "program/program.h"
#include "program/program_opt.h"
#include "program/program_srr.h"
#include "server/server_ser.h"
#include <err.h>
#include <errno.h>
#include <sys/dispatch.h>



// --------------------------------------------------> pr_Initialization <---

void pr_Initialization(int argc, char** argv, const char** path
, unsigned int* flags, int* rsize, int* psize)
{

	parms_t parms;

							//    
	OptProc (argc, argv, &parms);

							//   
	InitProgram ();
	pp = true;

							//    
	*path  = (const char*) PROGRAM_NAME;
	*flags = 0; // NAME_FLAG_ATTACH_GLOBAL;
	*rsize = sizeof (pr_r_msg_t);
	*psize = sizeof (pr_p_msg_t);
}

// ------------------------------------------------------> pr_Completing <---

void pr_Completing(void)
{
	if (pp) {
		CloseProgram ();
		pp = false;
	}

	se_Completing ();
}

// -------------------------------------------------> pr_ChannelDepended <---

void pr_ChannelDepended(int coid)
{
	se_ChannelDepended (coid);
}

// ------------------------------------------------------> pr_ProcessMsg <---

int pr_ProcessMsg(int rcvid, void * r_msg, void * p_msg, int* psize
, struct _msg_info* info)
{
	int rc;
	uint16_t type;

	type = ((se_r_cmd_t*) r_msg)->type;

	rc = ENOSYS;
	*psize = 0;

	switch (type) {

	// --->

	case pr_t_t1:
		rc = Func ();
		break;

	// <---

	default:
		rc = se_ProcessMsg (rcvid, r_msg, p_msg, psize, info);
		break;
	}

	return rc;
}

// ----------------------------------------------------> pr_ProcessPulse <---

void pr_ProcessPulse(pulse_t* pulse, struct _msg_info* info)
{
	switch (pulse->code) {

	// --->



	// <---

	default:
		se_ProcessPulse(pulse, info);
		break;
	}
}

//===========================================================================

