/****************************************************************************

	File    : sample\sample_lib.c  

	Project : server
	Version : 3.7
	Date    : Sat, 22, Sep 2018 

	Author  : Zheltikov I.A.

****************************************************************************/

#include "sample/sample_lib.h"
#include "sample/sample_srr.h"
#include <string.h>
#include <unistd.h>


const char* sa_name = SAMPLE_NAME;

static int rc;

// -------------------------------------------------------------> sa_Cmd <---

int sa_Cmd(int fd)
{
	se_r_cmd_t s_msg;

	s_msg.type = sa_t_cmd;

	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}

// --------------------------------------------------------------> sa_In <---

int sa_In(int fd, int in)
{
	sa_r_in_t s_msg;

	s_msg.type = sa_t_in;
	s_msg.in = in;

	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}

// -------------------------------------------------------------> sa_Out <---

int sa_Out(int fd, int* out)
{
	se_r_cmd_t s_msg;
	sa_p_out_t l_msg;

	s_msg.type = sa_t_out;

	rc = MsgSend (fd, &s_msg, sizeof (s_msg), &l_msg, sizeof (l_msg));

	*out = l_msg.out;

	return rc;
}

// -----------------------------------------------------------> sa_InOut <---

int sa_InOut(int fd, int in, int* out)
{
	sa_r_inout_t s_msg;
	sa_p_inout_t l_msg;

	s_msg.type = sa_t_inout;
	s_msg.in = in;

	rc = MsgSend (fd, &s_msg, sizeof (s_msg), &l_msg, sizeof (l_msg));

	*out = l_msg.out;

	return rc;
}

// ---------------------------------------------------------> sa_Delayed <---

int sa_Delayed(int fd, int in, int* out)
{
	sa_r_delayed_t s_msg;
	sa_p_delayed_t l_msg;

	s_msg.type = sa_t_delayed;
	s_msg.in = in;

	rc = MsgSend (fd, &s_msg, sizeof (s_msg), &l_msg, sizeof (l_msg));

	*out = l_msg.out;

	return rc;
}

// -----------------------------------------------------------> sa_Pulse <---

int sa_Pulse(int fd, int value)
{
	rc = MsgSendPulse (fd, SIGEV_PULSE_PRIO_INHERIT, sa_c_pulse, value);

	return rc;
}

// ---------------------------------------------------------> sa_Vectors <---

int sa_Vectors(int fd, char* in, int in_len, char* out, int* out_len)
{
	sa_r_vectors_t s_msg;
	sa_p_vectors_t l_msg;
	iov_t s_iov [2];
	iov_t l_iov [2];

	s_msg.type    = sa_t_vectors;
	s_msg.in_len  = in_len;
	s_msg.out_len = *out_len;

	SETIOV (s_iov + 0, &s_msg, sizeof (s_msg));
	SETIOV (s_iov + 1, in, in_len);

	SETIOV (l_iov + 0, &l_msg, sizeof (l_msg));
	SETIOV (l_iov + 1, out, *out_len);

	rc = MsgSendv (fd, s_iov, 2, l_iov, 2);

	*out_len = l_msg.out_len;

	return rc;
}

//===========================================================================

