/****************************************************************************

	File    : sample\sample_lib.h  

	Project : server
	Version : 3.7
	Date    : Sat, 22, Sep 2018 

	Author  : Zheltikov I.A.

****************************************************************************/

#ifndef sample_lib_h
#define sample_lib_h

#include "server/server_lib.h"


//  
extern const char* sa_name;

/* 
// sa_Cmd
// --------
//       .
//
// fd: [In] -  
*/
int sa_Cmd(int fd);

/* 
// sa_In
// --------
//     .
//
// fd: [In] -  
// in: [In] -  
*/
int sa_In(int fd, int in);

/* 
// sa_Out
// --------
//     .
//
// fd: [In] -  
// out: [Out] -  
*/
int sa_Out(int fd, int* out);

/* 
// sa_InOut
// --------
//       .
//
// fd: [In] -  
// in: [In] -  
// out: [Out] -  
*/
int sa_InOut(int fd, int in, int* out);

/* 
// sa_Delayed
// --------
//          .
//
// fd: [In] -  
// in: [In] -  
// out: [Out] -  
*/
int sa_Delayed(int fd, int in, int* out);

/* 
// sa_Pulse
// --------
//       .
//
// fd: [In] -  
// value: [In] -  
*/
int sa_Pulse(int fd, int value);

/* 
// sa_Vectors
// --------
//          .
//
// fd: [In] -  
// in: [In] -  
// in_len: [In] -   
// out: [In] -  
// out_len: [Out] -   
*/
int sa_Vectors(int fd, char* in, int in_len, char* out, int* out_len);

#endif

//===========================================================================

