/****************************************************************************

	File    : sample\sample_opt.c  

	Project : server
	Version : 3.7
	Date    : Sat, 22, Sep 2018 

	Author  : Zheltikov I.A.

****************************************************************************/

#include "sample/sample_opt.h"
#include "server/tools.h"
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


// ==============================================================> usage <===
/*
#ifdef __USAGE
%C - sample program

%C [-f] [-p param] &
Options:
 -f  flag (default off)
 -p  parameter value (default 100)

Examples:
%C -f &
%C -p 20 &
%C -p 40 -f &
#endif
*/



static parms_t parms_def = {false, 100};

static void Opt_f(char* optarg);

static void Opt_p(char* optarg);

// ------------------------------------------------------------> OptProc <---

void OptProc(int argc, char** argv, parms_t* parms)
{
	int c;

	    						//   ,
	    						//    
	opterr = 0;
	while (1) {
		c = getopt (argc, argv, "fp:");   // <---

		if (c == -1 && argv [optind] == NULL)
			break;

		switch (c) {

		// --->

		case 'f': 
			Opt_f (optarg); 
			break;

		case 'p': 
			Opt_p (optarg); 
			break;

		// <---    

		default:
			Usage ();
			exit (EXIT_FAILURE);
			break;
		}
	}

	*parms = parms_def;
}

// --------------------------------------------------------------> Opt_f <---

static void Opt_f(char* optarg)
{
	parms_def.flag = true;
}

// --------------------------------------------------------------> Opt_p <---

static void Opt_p(char* optarg)
{
	parms_def.param = atoi (optarg);
}

//===========================================================================

