/****************************************************************************

	File    : server\server_lib.c  

	Project : server
	Version : 3.7
	Date    : Sat, 22, Sep 2018 

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "server/server_lib.h"
#include "server/server_srr.h"
#include <err.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/dispatch.h>


//  

const char* se_name = SERVER_NAME;

static int rc;

// ------------------------------------------------------------> se_Open <---

int se_Open(const char* name, unsigned int flags)
{
	int i;

	for (i = 0; i < 100; i++) {
		rc = name_open (name, flags);

		if (rc == -1 && errno == ENOENT)
			delay (50);
		else
			break;
	}

	return rc;
}

// ---------------------------------------------------------> se_OpenErr <---

int se_OpenErr(const char* name, unsigned int flags)
{
	rc = se_Open (name, flags);
							if (rc == -1) err (EXIT_FAILURE,
							"Can not open '%s'", name);

	return rc;
}

// -----------------------------------------------------------> se_Close <---

int se_Close(int fd)
{
	rc = name_close (fd);

	return rc;
}

// --------------------------------------------------------> se_Complete <---

int se_Complete(int fd)
{
	se_r_cmd_t s_msg;

	s_msg.type = se_t_quit;

	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}

// -------------------------------------------------> se_CompleteByPulse <---

int se_CompleteByPulse(int fd)
{
	rc = MsgSendPulse (fd, SIGEV_PULSE_PRIO_INHERIT, se_c_quit, 0);

	return rc;
}

// ----------------------------------------------> se_EventForDelivering <---

int se_EventForDelivering(int fd, sigevent_t* event)
{
	se_r_evdlvr_t s_msg;

	s_msg.type  = se_t_evdlvr;
	s_msg.event = *event;

	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}

//===========================================================================

