/****************************************************************************

	File    : server\server_lib.h  

	Project : server
	Version : 3.7
	Date    : Sat, 22, Sep 2018 

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#ifndef server_lib_h
#define server_lib_h

#include "server/server_types.h"

//    .
// 
//  ,  se_Open()  se_Close()    
// .   se_Open()     , 
// .  se_Close() ,    se_Open().

//  
extern const char* se_name;

/* 
// se_Open
// --------
//          .
// 
//   .
// 
//   100       
//   50 . ,     5  , 
//        .
//
// name: [In] -  
// flags: [In] -   ,   
*/
int se_Open(const char* name, unsigned int flags);

/* 
// se_OpenErr
// --------
//          .
//        .
// 
//   .
//
// name: [In] -  
// flags: [In] -   ,   
*/
int se_OpenErr(const char* name, unsigned int flags);

/* 
// se_Close
// --------
//       .
//
// fd: [In] -  
*/
int se_Close(int fd);

/* 
// se_Complete
// --------
//     .
//
// fd: [In] -  
*/
int se_Complete(int fd);

/* 
// se_CompleteByPulse
// --------
//     ,  .
//
// fd: [In] -  
*/
int se_CompleteByPulse(int fd);

/* 
// se_EventForDelivering
// --------
//         .
//
// fd: [In] -  
// event: [In] -   
*/
int se_EventForDelivering(int fd, sigevent_t* event);

#endif

//===========================================================================

