/****************************************************************************

	File    : server\server_ser.c  

	Project : server
	Version : 3.7
	Date    : Sat, 22, Sep 2018 

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "server/server_ser.h"
#include "server/server.h"
#include "server/server_opt.h"
#include "server/server_srr.h"
#include "server/server_fix.h"
#include <err.h>
#include <errno.h>


bool pp = false;


// --------------------------------------------------> se_Initialization <---

void se_Initialization(int argc, char** argv, const char** path
, unsigned int* flags, int* rsize, int* psize)
{

	parms_t parms;

							//    
	OptProc (argc, argv, &parms);

							//   
	InitServer ();
	pp = true;

							//    
	*path  = (const char*) SERVER_NAME;
	*flags = 0;
	*rsize = sizeof (se_r_msg_t);
	*psize = sizeof (se_p_msg_t);
}

// ------------------------------------------------------> se_Completing <---

void se_Completing(void)
{
	if (pp) {
		CloseServer ();
		pp = false;
	}

	ServerFixCompleting ();
}

// -------------------------------------------------> se_ChannelDepended <---

void se_ChannelDepended(int coid)
{
}

// ------------------------------------------------------> se_ProcessMsg <---

int se_ProcessMsg(int rcvid, void * r_msg, void * p_msg, int* psize
, struct _msg_info* info)
{
	int rc;
	uint16_t type;

	type = ((se_r_cmd_t*) r_msg)->type;

	rc = ENOSYS;
	*psize = 0;

	switch (type) {

	case se_t_quit:
		rc = Complete (&is_srr_running);
		break;

	case se_t_evdlvr: {
		se_r_evdlvr_t* rmsg = (se_r_evdlvr_t*) r_msg;
		rc = EventForDelivering (rcvid, &(rmsg->event));
		break;
	}

	case _IO_CONNECT:
	case _IO_CLOSE:
		rc = EOK;
		break;

	default:
		warnx ("unsupported command type=%d", type);
		rc = ENOSYS;
		break;
	}

	return rc;
}

// ----------------------------------------------------> se_ProcessPulse <---

void se_ProcessPulse(pulse_t* pulse, struct _msg_info* info)
{
	switch (pulse->code) {

	case se_c_quit:
		CompleteByPulse (&is_srr_running);
		break;

	case _PULSE_CODE_DISCONNECT:
		ConnectDetach (pulse->scoid);
		break;

	case _PULSE_CODE_UNBLOCK:
	case _PULSE_CODE_THREADDEATH:
	case _PULSE_CODE_COIDDEATH:
	case _PULSE_CODE_NET_ACK:
	case _PULSE_CODE_NET_UNBLOCK:
	case _PULSE_CODE_NET_DETACH:
		break;

	default:
		warnx ("unsupported pulse code=%d", pulse->code);
		break;
	}
}

//===========================================================================

