/****************************************************************************

	File    : Program\SProgram.cpp  

	Project : Server
	Version : 1.0
	Date    : Sat, 22, Sep 2018  

	Author  : Zheltikov I.A.

****************************************************************************/

#include "Program/SProgram.h"
#include "Program/PProgram.h"
#include "Program/OProgram.h"
#include <err.h>
#include <errno.h>
#include <sys/dispatch.h>

SProgram::SProgram()
{
}

SProgram::~SProgram()
{
}

// -----------------------------------------------------> Initialization <---

void SProgram::Initialization(int argc, char** argv, const char** path
, unsigned int* flags, int* rsize, int* psize)
{

	OProgram::parms_t parms;
	OProgram opt;

							//    
	opt.OptProc (argc, argv, &parms);

							//   
	pp = new PProgram ();

							//    
	*path  = (const char*) PROGRAM_NAME;
	*flags = 0; // NAME_FLAG_ATTACH_GLOBAL
	*rsize = sizeof (pr_r_msg_t);
	*psize = sizeof (pr_p_msg_t);
}

// ---------------------------------------------------------> Completing <---

void SProgram::Completing()
{
	if (pp != NULL) {
		delete (PProgram*) pp;
		pp = NULL;
	}

	SServer::Completing ();
}

// ----------------------------------------------------> ChannelDepended <---

void SProgram::ChannelDepended(int coid)
{
	SServer::ChannelDepended(coid);
}

// ---------------------------------------------------------> ProcessMsg <---

int SProgram::ProcessMsg(int rcvid, void * r_msg, void * p_msg, int* psize
, struct _msg_info* info)
{
	int rc;
	uint16_t type;
	PProgram* p;

	p    = (PProgram*) pp;
	type = ((se_r_cmd_t*) r_msg)->type;

	rc = ENOSYS;
	*psize = 0;

	switch (type) {

	// --->

	case pr_t_t1:
		rc = p->Func ();
		break;

	// <---    

	default:
		rc = SServer::ProcessMsg (rcvid, r_msg, p_msg, psize, info);
		break;
	}

	return rc;
}

// -------------------------------------------------------> ProcessPulse <---

void SProgram::ProcessPulse(pulse_t* pulse, struct _msg_info* info)
{
	PProgram* p;

	p = (PProgram*) pp;

	switch (pulse->code) {

	// --->



	// <---

	default:
		SServer::ProcessPulse (pulse, info);
		break;
	}
}


//===========================================================================

