/****************************************************************************

	File    : Sample\ISample.h  

	Project : Server
	Version : 1.0
	Date    : Sat, 22, Sep 2018  

	Author  : Zheltikov I.A.

****************************************************************************/

#ifndef ISample_H
#define ISample_H

#include "Server/IServer.h"

class ISample : public IServer {


public :

	//  
	const char* name;

	ISample();

	~ISample();

	/* 
	// Cmd
	// --------
	//      .
	//
	// 
	*/
	int Cmd();

	/* 
	// In
	// --------
	//     .
	//
	// in: [In] -  
	*/
	int In(int in);

	/* 
	// Out
	// --------
	//     .
	//
	// out: [Out] -  
	*/
	int Out(int* out);

	/* 
	// InOut
	// --------
	//       .
	//
	// in: [In] -  
	// out: [Out] -  
	*/
	int InOut(int in, int* out);

	/* 
	// Delayed
	// --------
	//          .
	//
	// in: [In] -  
	// out: [Out] -  
	*/
	int Delayed(int in, int* out);

	/* 
	// Vectors
	// --------
	//          .
	//
	// in: [In] -  
	// in_len: [In] -   
	// out: [Out] -  
	// out_len: [InOut] -   
	*/
	int Vectors(char* in, int in_len, char* out, int* out_len);

	/* 
	// Pulse
	// --------
	//       .
	//
	// value: [In] -  
	*/
	int Pulse(int value);

};

#endif

//===========================================================================

