/****************************************************************************

	File    : Sample\OSample.cpp  

	Project : Server
	Version : 1.0
	Date    : Sat, 22, Sep 2018  

	Author  : Zheltikov I.A.

****************************************************************************/

#include "Sample/OSample.h"
#include "Server/Tools.h"
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


// ==============================================================> usage <===
/*
#ifdef __USAGE
%C - 

%C &
Options:

Examples:
%C &
#endif
*/


OSample::OSample()
{
	parms_def = (parms_t) {false,100};
}

OSample::~OSample()
{
}

// ------------------------------------------------------------> OptProc <---

void OSample::OptProc(int argc, char** argv, OSample::parms_t* parms)
{
	int c;
	Tools tools;

	    						//   ,
	    						//    
	opterr = 0;
	while (1) {
		c = getopt (argc, argv, "fp:");   // <---

		if (c == -1 && argv[optind] == NULL)
			break;

		switch (c) {

		// --->

		case 'f': 
			Opt_f (optarg); 
			break;

		case 'p': 
			Opt_p (optarg); 
			break;

		// <---

		default:
			tools.Usage ();
			exit (EXIT_FAILURE);
			break;
		}
	}

	*parms = parms_def;
}

// --------------------------------------------------------------> Opt_f <---

void OSample::Opt_f(char* optarg)
{
	parms_def.flag = true;
}

// --------------------------------------------------------------> Opt_p <---

void OSample::Opt_p(char* optarg)
{
	parms_def.param = atoi (optarg);
}


//===========================================================================

