/****************************************************************************

	File    : Sample\Sample.h  

	Project : Server
	Version : 1.0
	Date    : Sat, 22, Sep 2018  

	Author  : Zheltikov I.A.

****************************************************************************/

#ifndef Sample_H
#define Sample_H

#include "Server/Server.h"


enum sa_types_t {
	sa_t_cmd = SE_TYPE_FIRST + SE_TYPE_STEP * 1,
	sa_t_in,
	sa_t_out,
	sa_t_inout,
	sa_t_delayed,
	sa_t_vectors
};

enum sa_codes_t {
	sa_c_self = SE_CODE_FIRST + SE_CODE_STEP * 1,
	sa_c_pulse,
	sa_c_timer
};

typedef struct sa_r_in_t {
	uint16_t type;
	int in;
} sa_r_in_t;

typedef struct sa_r_inout_t {
	uint16_t type;
	int in;
} sa_r_inout_t;

typedef struct sa_r_delayed_t {
	uint16_t type;
	int in;
} sa_r_delayed_t;

typedef struct sa_r_vectors_t {
	uint16_t type;
	int in_len;
	int out_len;
} sa_r_vectors_t;

typedef union sa_r_msg_t {
	uint16_t type;
	se_r_msg_t server;
	sa_r_in_t in;
	sa_r_inout_t inout;
	sa_r_delayed_t delayed;
	sa_r_vectors_t vectors;
} sa_r_msg_t;

typedef struct sa_p_out_t {
	int out;
} sa_p_out_t;

typedef struct sa_p_inout_t {
	int out;
} sa_p_inout_t;

typedef struct sa_p_delayed_t {
	int out;
} sa_p_delayed_t;

typedef struct sa_p_vectors_t {
	int out_len;
} sa_p_vectors_t;

typedef union sa_p_msg_t {
	se_p_msg_t server;
	sa_p_out_t out;
	sa_p_inout_t inout;
	sa_p_delayed_t delayed;
	sa_p_vectors_t vectors;
} sa_p_msg_t;

#define SAMPLE_NAME "sample"

int main(int argc, char** argv);

#endif

//===========================================================================

