/****************************************************************************

	File    : Server\IServer.cpp  

	Project : Server
	Version : 3.7
	Date    : Sat, 22, Sep 2018  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Server/IServer.h"
#include "Server/Server.h"
#include <err.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/dispatch.h>

IServer::IServer()
{
	fd = -1;
	name = SERVER_NAME;
}

IServer::~IServer()
{
}

// ---------------------------------------------------------------> Open <---

int IServer::Open(const char* name, unsigned int flags)
{
	int i;

	for (i = 0; i < 100; i++) {
		rc = name_open (name, flags);

		if (rc == -1 && errno == ENOENT)
			delay (50);
		else
			break;
	}

	fd = rc;

	return rc;
}

// ------------------------------------------------------------> OpenErr <---

int IServer::OpenErr(const char* name, unsigned int flags)
{
	rc = Open (name, flags);
							if (rc == -1) err (EXIT_FAILURE,
							"Can not open '%s'", name);

	return rc;
}

// --------------------------------------------------------------> Close <---

int IServer::Close()
{
	rc = name_close (fd);
	fd = -1;

	return rc;
}

// -----------------------------------------------------------> Complete <---

int IServer::Complete()
{
	se_r_cmd_t s_msg;

	s_msg.type = se_t_quit;

	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}

// ----------------------------------------------------> CompleteByPulse <---

int IServer::CompleteByPulse()
{
	rc = MsgSendPulse (fd, SIGEV_PULSE_PRIO_INHERIT, se_c_quit, 0);

	return rc;
}

// -------------------------------------------------> EventForDelivering <---

int IServer::EventForDelivering(sigevent_t* event)
{
	se_r_evdlvr_t s_msg;

	s_msg.type  = se_t_evdlvr;
	s_msg.event = *event;

	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}


//===========================================================================

