/****************************************************************************

	File    : Server\IServer.h  

	Project : Server
	Version : 3.7
	Date    : Sat, 22, Sep 2018  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#ifndef IServer_H
#define IServer_H

#include "Server/server_types.h"

//    .
// 
//  ,  Open()  Close()     .
//      ,     
//    .  ,   Open()  
//   .  Close() ,    Open().
// 
class IServer {

public :

	IServer();

	~IServer();

	//  
	const char* name;

	/* 
	// Open
	// --------
	//          .
	// 
	//   .
	// 
	//   100       
	//   50 . ,     5  , 
	//        .
	//
	// name: [In] -  
	// flags: [In] -   ,   
	*/
	int Open(const char* name, unsigned int flags);

	/* 
	// OpenErr
	// --------
	//          .
	//        .
	// 
	//   .
	//
	// name: [In] -  
	// flags: [In] -   ,   
	*/
	int OpenErr(const char* name, unsigned int flags);

	/* 
	// Close
	// --------
	//       .
	//
	// 
	*/
	int Close();

	/* 
	// Complete
	// --------
	//     .
	//
	// 
	*/
	int Complete();

	/* 
	// CompleteByPulse
	// --------
	//     ,  .
	//
	// 
	*/
	int CompleteByPulse();

	/* 
	// EventForDelivering
	// --------
	//         .
	//
	// event: [In] -   
	*/
	int EventForDelivering(sigevent_t* event);


protected :

	//  
	int fd;

	//  
	int rc;

};

#endif

//===========================================================================

